/*
 * Copyright 2010-2018 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license
 * that can be found in the license/LICENSE.txt file.
 */

package org.jetbrains.kotlin.idea.quickfix;

import com.intellij.testFramework.TestDataPath;
import org.jetbrains.kotlin.test.JUnit3RunnerWithInners;
import org.jetbrains.kotlin.test.KotlinTestUtils;
import org.jetbrains.kotlin.test.TargetBackend;
import org.jetbrains.kotlin.test.TestMetadata;
import org.junit.runner.RunWith;

import java.io.File;
import java.util.regex.Pattern;

/** This class is generated by {@link org.jetbrains.kotlin.generators.tests.TestsPackage}. DO NOT MODIFY MANUALLY */
@SuppressWarnings("all")
@TestMetadata("idea/testData/multiModuleQuickFix")
@TestDataPath("$PROJECT_ROOT")
@RunWith(JUnit3RunnerWithInners.class)
public class QuickFixMultiModuleTestGenerated extends AbstractQuickFixMultiModuleTest {
    private void runTest(String testDataFilePath) throws Exception {
        KotlinTestUtils.runTest(this::doTest, TargetBackend.ANY, testDataFilePath);
    }

    @TestMetadata("abstract")
    public void testAbstract() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/abstract/");
    }

    @TestMetadata("addActualToClass")
    public void testAddActualToClass() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/addActualToClass/");
    }

    @TestMetadata("addActualToClassMember")
    public void testAddActualToClassMember() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/addActualToClassMember/");
    }

    @TestMetadata("addActualToTopLevelMember")
    public void testAddActualToTopLevelMember() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/addActualToTopLevelMember/");
    }

    @TestMetadata("addOperatorByHeader")
    public void testAddOperatorByHeader() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/addOperatorByHeader/");
    }

    @TestMetadata("addOperatorByImpl")
    public void testAddOperatorByImpl() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/addOperatorByImpl/");
    }

    public void testAllFilesPresentInMultiModuleQuickFix() throws Exception {
        KotlinTestUtils.assertAllTestsPresentByMetadata(this.getClass(), new File("idea/testData/multiModuleQuickFix"), Pattern.compile("^([^\\.]+)$"), TargetBackend.ANY, false);
    }

    @TestMetadata("annotation")
    public void testAnnotation() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/annotation/");
    }

    @TestMetadata("class")
    public void testClass() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/class/");
    }

    @TestMetadata("classFunction")
    public void testClassFunction() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/classFunction/");
    }

    @TestMetadata("classOverloadedFunction")
    public void testClassOverloadedFunction() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/classOverloadedFunction/");
    }

    @TestMetadata("classSomeProperties")
    public void testClassSomeProperties() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/classSomeProperties/");
    }

    @TestMetadata("companionAbsence")
    public void testCompanionAbsence() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/companionAbsence/");
    }

    @TestMetadata("convertActualEnumToSealedClass")
    public void testConvertActualEnumToSealedClass() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/convertActualEnumToSealedClass/");
    }

    @TestMetadata("convertActualSealedClassToEnum")
    public void testConvertActualSealedClassToEnum() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/convertActualSealedClassToEnum/");
    }

    @TestMetadata("convertExpectEnumToSealedClass")
    public void testConvertExpectEnumToSealedClass() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/convertExpectEnumToSealedClass/");
    }

    @TestMetadata("convertExpectSealedClassToEnum")
    public void testConvertExpectSealedClassToEnum() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/convertExpectSealedClassToEnum/");
    }

    @TestMetadata("createFunInExpectClass")
    public void testCreateFunInExpectClass() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/createFunInExpectClass/");
    }

    @TestMetadata("createValInExpectClass")
    public void testCreateValInExpectClass() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/createValInExpectClass/");
    }

    @TestMetadata("createVarInExpectClass")
    public void testCreateVarInExpectClass() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/createVarInExpectClass/");
    }

    @TestMetadata("deprecatedHeader")
    public void testDeprecatedHeader() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/deprecatedHeader/");
    }

    @TestMetadata("deprecatedHeaderImpl")
    public void testDeprecatedHeaderImpl() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/deprecatedHeaderImpl/");
    }

    @TestMetadata("deprecatedImpl")
    public void testDeprecatedImpl() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/deprecatedImpl/");
    }

    @TestMetadata("deprecatedImplHeader")
    public void testDeprecatedImplHeader() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/deprecatedImplHeader/");
    }

    @TestMetadata("enum")
    public void testEnum() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/enum/");
    }

    @TestMetadata("function")
    public void testFunction() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/function/");
    }

    @TestMetadata("functionSameFile")
    public void testFunctionSameFile() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/functionSameFile/");
    }

    @TestMetadata("functionTypeParameterToReceiverByHeader")
    public void testFunctionTypeParameterToReceiverByHeader() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/functionTypeParameterToReceiverByHeader/");
    }

    @TestMetadata("functionTypeParameterToReceiverByImpl")
    public void testFunctionTypeParameterToReceiverByImpl() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/functionTypeParameterToReceiverByImpl/");
    }

    @TestMetadata("functionTypeReceiverToParameterByHeader")
    public void testFunctionTypeReceiverToParameterByHeader() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/functionTypeReceiverToParameterByHeader/");
    }

    @TestMetadata("functionTypeReceiverToParameterByImpl")
    public void testFunctionTypeReceiverToParameterByImpl() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/functionTypeReceiverToParameterByImpl/");
    }

    @TestMetadata("implementMembersInImplClassNonImplInheritor")
    public void testImplementMembersInImplClassNonImplInheritor() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/implementMembersInImplClassNonImplInheritor/");
    }

    @TestMetadata("importClassInCommon")
    public void testImportClassInCommon() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/importClassInCommon/");
    }

    @TestMetadata("importClassInFromProductionInCommonTests")
    public void testImportClassInFromProductionInCommonTests() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/importClassInFromProductionInCommonTests/");
    }

    @TestMetadata("importCommonClassInJs")
    public void testImportCommonClassInJs() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/importCommonClassInJs/");
    }

    @TestMetadata("importCommonClassInJvm")
    public void testImportCommonClassInJvm() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/importCommonClassInJvm/");
    }

    @TestMetadata("importCommonFunInJvm")
    public void testImportCommonFunInJvm() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/importCommonFunInJvm/");
    }

    @TestMetadata("importExpectClassWithActualInJvm")
    public void testImportExpectClassWithActualInJvm() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/importExpectClassWithActualInJvm/");
    }

    @TestMetadata("importExpectClassWithoutActualInJvm")
    public void testImportExpectClassWithoutActualInJvm() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/importExpectClassWithoutActualInJvm/");
    }

    @TestMetadata("importFunInCommon")
    public void testImportFunInCommon() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/importFunInCommon/");
    }

    @TestMetadata("interface")
    public void testInterface() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/interface/");
    }

    @TestMetadata("memberFunParameterToReceiverByHeader")
    public void testMemberFunParameterToReceiverByHeader() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/memberFunParameterToReceiverByHeader/");
    }

    @TestMetadata("memberFunParameterToReceiverByImpl")
    public void testMemberFunParameterToReceiverByImpl() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/memberFunParameterToReceiverByImpl/");
    }

    @TestMetadata("memberFunReceiverToParameterByHeader")
    public void testMemberFunReceiverToParameterByHeader() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/memberFunReceiverToParameterByHeader/");
    }

    @TestMetadata("memberFunReceiverToParameterByImpl")
    public void testMemberFunReceiverToParameterByImpl() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/memberFunReceiverToParameterByImpl/");
    }

    @TestMetadata("memberFunToExtensionByHeader")
    public void testMemberFunToExtensionByHeader() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/memberFunToExtensionByHeader/");
    }

    @TestMetadata("memberFunToExtensionByImpl")
    public void testMemberFunToExtensionByImpl() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/memberFunToExtensionByImpl/");
    }

    @TestMetadata("memberValToExtensionByHeader")
    public void testMemberValToExtensionByHeader() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/memberValToExtensionByHeader/");
    }

    @TestMetadata("memberValToExtensionByHeaderWithInapplicableImpl")
    public void testMemberValToExtensionByHeaderWithInapplicableImpl() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/memberValToExtensionByHeaderWithInapplicableImpl/");
    }

    @TestMetadata("memberValToExtensionByImpl")
    public void testMemberValToExtensionByImpl() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/memberValToExtensionByImpl/");
    }

    @TestMetadata("nested")
    public void testNested() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/nested/");
    }

    @TestMetadata("object")
    public void testObject() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/object/");
    }

    @TestMetadata("orderHeader")
    public void testOrderHeader() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/orderHeader/");
    }

    @TestMetadata("orderImpl")
    public void testOrderImpl() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/orderImpl/");
    }

    @TestMetadata("package")
    public void testPackage() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/package/");
    }

    @TestMetadata("packageIncorrect")
    public void testPackageIncorrect() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/packageIncorrect/");
    }

    @TestMetadata("packageIncorrectEmpty")
    public void testPackageIncorrectEmpty() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/packageIncorrectEmpty/");
    }

    @TestMetadata("primaryConstructor")
    public void testPrimaryConstructor() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/primaryConstructor/");
    }

    @TestMetadata("primaryConstructorAbsence")
    public void testPrimaryConstructorAbsence() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/primaryConstructorAbsence/");
    }

    @TestMetadata("property")
    public void testProperty() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/property/");
    }

    @TestMetadata("sealed")
    public void testSealed() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/sealed/");
    }

    @TestMetadata("sealedSubclass")
    public void testSealedSubclass() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/sealedSubclass/");
    }

    @TestMetadata("secondaryConstructorAbsence")
    public void testSecondaryConstructorAbsence() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/secondaryConstructorAbsence/");
    }

    @TestMetadata("withFakeJvm")
    public void testWithFakeJvm() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/withFakeJvm/");
    }

    @TestMetadata("withTest")
    public void testWithTest() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/withTest/");
    }

    @TestMetadata("withTestDummy")
    public void testWithTestDummy() throws Exception {
        runTest("idea/testData/multiModuleQuickFix/withTestDummy/");
    }
}
