/*
 * Copyright 2010-2018 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license
 * that can be found in the license/LICENSE.txt file.
 */

package org.jetbrains.kotlin.idea.refactoring.safeDelete;

import com.intellij.testFramework.TestDataPath;
import org.jetbrains.kotlin.test.JUnit3RunnerWithInners;
import org.jetbrains.kotlin.test.KotlinTestUtils;
import org.jetbrains.kotlin.test.TargetBackend;
import org.jetbrains.kotlin.test.TestMetadata;
import org.junit.runner.RunWith;

import java.io.File;
import java.util.regex.Pattern;

/** This class is generated by {@link org.jetbrains.kotlin.generators.tests.TestsPackage}. DO NOT MODIFY MANUALLY */
@SuppressWarnings("all")
@TestMetadata("idea/testData/refactoring/safeDeleteMultiModule")
@TestDataPath("$PROJECT_ROOT")
@RunWith(JUnit3RunnerWithInners.class)
public class MultiModuleSafeDeleteTestGenerated extends AbstractMultiModuleSafeDeleteTest {
    private void runTest(String testDataFilePath) throws Exception {
        KotlinTestUtils.runTest(this::doTest, TargetBackend.ANY, testDataFilePath);
    }

    public void testAllFilesPresentInSafeDeleteMultiModule() throws Exception {
        KotlinTestUtils.assertAllTestsPresentInSingleGeneratedClass(this.getClass(), new File("idea/testData/refactoring/safeDeleteMultiModule"), Pattern.compile("^(.+)\\.test$"), TargetBackend.ANY);
    }

    @TestMetadata("byHeaderClass/byHeaderClass.test")
    public void testByHeaderClass_ByHeaderClass() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byHeaderClass/byHeaderClass.test");
    }

    @TestMetadata("byHeaderClassMemberFun/byHeaderClassMemberFun.test")
    public void testByHeaderClassMemberFun_ByHeaderClassMemberFun() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byHeaderClassMemberFun/byHeaderClassMemberFun.test");
    }

    @TestMetadata("byHeaderClassMemberFunParameter/byHeaderClassMemberFunParameter.test")
    public void testByHeaderClassMemberFunParameter_ByHeaderClassMemberFunParameter() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byHeaderClassMemberFunParameter/byHeaderClassMemberFunParameter.test");
    }

    @TestMetadata("byHeaderClassMemberVal/byHeaderClassMemberVal.test")
    public void testByHeaderClassMemberVal_ByHeaderClassMemberVal() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byHeaderClassMemberVal/byHeaderClassMemberVal.test");
    }

    @TestMetadata("byHeaderClassPrimaryConstructorParameter/headersAndImplsByHeaderClassPrimaryConstructorParameter.test")
    public void testByHeaderClassPrimaryConstructorParameter_HeadersAndImplsByHeaderClassPrimaryConstructorParameter() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byHeaderClassPrimaryConstructorParameter/headersAndImplsByHeaderClassPrimaryConstructorParameter.test");
    }

    @TestMetadata("byHeaderClassSecondaryConstructor/byHeaderClassSecondaryConstructor.test")
    public void testByHeaderClassSecondaryConstructor_ByHeaderClassSecondaryConstructor() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byHeaderClassSecondaryConstructor/byHeaderClassSecondaryConstructor.test");
    }

    @TestMetadata("byHeaderClassSecondaryConstructorParameter/headersAndImplsByHeaderClassSecondaryConstructorParameter.test")
    public void testByHeaderClassSecondaryConstructorParameter_HeadersAndImplsByHeaderClassSecondaryConstructorParameter() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byHeaderClassSecondaryConstructorParameter/headersAndImplsByHeaderClassSecondaryConstructorParameter.test");
    }

    @TestMetadata("byHeaderFun/byHeaderFun.test")
    public void testByHeaderFun_ByHeaderFun() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byHeaderFun/byHeaderFun.test");
    }

    @TestMetadata("byHeaderFunParamerer/byHeaderFunParameter.test")
    public void testByHeaderFunParamerer_ByHeaderFunParameter() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byHeaderFunParamerer/byHeaderFunParameter.test");
    }

    @TestMetadata("byHeaderFunVarargParamerer/byHeaderFunVarargParameter.test")
    public void testByHeaderFunVarargParamerer_ByHeaderFunVarargParameter() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byHeaderFunVarargParamerer/byHeaderFunVarargParameter.test");
    }

    @TestMetadata("byHeaderVal/byHeaderVal.test")
    public void testByHeaderVal_ByHeaderVal() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byHeaderVal/byHeaderVal.test");
    }

    @TestMetadata("byImplClass/byImplClass.test")
    public void testByImplClass_ByImplClass() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byImplClass/byImplClass.test");
    }

    @TestMetadata("byImplClassMemberFun/byImplClassMemberFun.test")
    public void testByImplClassMemberFun_ByImplClassMemberFun() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byImplClassMemberFun/byImplClassMemberFun.test");
    }

    @TestMetadata("byImplClassMemberFunParameterLiftingToHeader/byImplClassMemberFunParameterLiftingToHeader.test")
    public void testByImplClassMemberFunParameterLiftingToHeader_ByImplClassMemberFunParameterLiftingToHeader() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byImplClassMemberFunParameterLiftingToHeader/byImplClassMemberFunParameterLiftingToHeader.test");
    }

    @TestMetadata("byImplClassMemberVal/byImplClassMemberVal.test")
    public void testByImplClassMemberVal_ByImplClassMemberVal() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byImplClassMemberVal/byImplClassMemberVal.test");
    }

    @TestMetadata("byImplClassPrimaryConstructorParameterLiftingToHeader/headersAndImplsByImplClassPrimaryConstructorParameter.test")
    public void testByImplClassPrimaryConstructorParameterLiftingToHeader_HeadersAndImplsByImplClassPrimaryConstructorParameter() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byImplClassPrimaryConstructorParameterLiftingToHeader/headersAndImplsByImplClassPrimaryConstructorParameter.test");
    }

    @TestMetadata("byImplClassSecondaryConstructor/byImplClassSecondaryConstructor.test")
    public void testByImplClassSecondaryConstructor_ByImplClassSecondaryConstructor() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byImplClassSecondaryConstructor/byImplClassSecondaryConstructor.test");
    }

    @TestMetadata("byImplClassSecondaryConstructorParameterLiftingToHeader/headersAndImplsByImplClassSecondaryConstructorParameter.test")
    public void testByImplClassSecondaryConstructorParameterLiftingToHeader_HeadersAndImplsByImplClassSecondaryConstructorParameter() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byImplClassSecondaryConstructorParameterLiftingToHeader/headersAndImplsByImplClassSecondaryConstructorParameter.test");
    }

    @TestMetadata("byImplFun/byImplFun.test")
    public void testByImplFun_ByImplFun() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byImplFun/byImplFun.test");
    }

    @TestMetadata("byImplFunParamererLiftingToHeader/byImplFunParameterLiftingToHeader.test")
    public void testByImplFunParamererLiftingToHeader_ByImplFunParameterLiftingToHeader() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byImplFunParamererLiftingToHeader/byImplFunParameterLiftingToHeader.test");
    }

    @TestMetadata("byImplFunParamererNoLiftingToHeader/byImplFunParameterNoLiftingToHeader.test")
    public void testByImplFunParamererNoLiftingToHeader_ByImplFunParameterNoLiftingToHeader() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byImplFunParamererNoLiftingToHeader/byImplFunParameterNoLiftingToHeader.test");
    }

    @TestMetadata("byImplVal/byImplVal.test")
    public void testByImplVal_ByImplVal() throws Exception {
        runTest("idea/testData/refactoring/safeDeleteMultiModule/byImplVal/byImplVal.test");
    }
}
